# 索引

  * [ tkl_wifi_init](#tkl_wifi_init)
  * [ tkl_wifi_scan_ap](#tkl_wifi_scan_ap)
  * [ tkl_wifi_release_ap](#tkl_wifi_release_ap)
  * [ tkl_wifi_start_ap](#tkl_wifi_start_ap)
  * [ tkl_wifi_stop_ap](#tkl_wifi_stop_ap)
  * [ tkl_wifi_set_cur_channel](#tkl_wifi_set_cur_channel)
  * [ tkl_wifi_get_cur_channel](#tkl_wifi_get_cur_channel)
  * [ tkl_wifi_set_sniffer](#tkl_wifi_set_sniffer)
  * [ tkl_wifi_get_ip](#tkl_wifi_get_ip)
  * [ tkl_wifi_set_ip](#tkl_wifi_set_ip)
  * [ tkl_wifi_set_mac](#tkl_wifi_set_mac)
  * [ tkl_wifi_get_mac](#tkl_wifi_get_mac)
  * [ tkl_wifi_set_work_mode](#tkl_wifi_set_work_mode)
  * [ tkl_wifi_get_work_mode](#tkl_wifi_get_work_mode)
  * [ tkl_wifi_get_connected_ap_info](#tkl_wifi_get_connected_ap_info)
  * [ tkl_wifi_get_bssid](#tkl_wifi_get_bssid)
  * [ tkl_wifi_set_country_code](#tkl_wifi_set_country_code)
  * [ tkl_wifi_set_rf_calibrated](#tkl_wifi_set_rf_calibrated)
  * [ tkl_wifi_set_lp_mode](#tkl_wifi_set_lp_mode)
  * [ tkl_wifi_station_fast_connect](#tkl_wifi_station_fast_connect)
  * [ tkl_wifi_station_connect](#tkl_wifi_station_connect)
  * [ tkl_wifi_station_disconnect](#tkl_wifi_station_disconnect)
  * [ tkl_wifi_station_get_conn_ap_rssi](#tkl_wifi_station_get_conn_ap_rssi)
  * [ tkl_wifi_station_get_status](#tkl_wifi_station_get_status)
  * [ tkl_wifi_send_mgnt](#tkl_wifi_send_mgnt)
  * [ tkl_wifi_register_recv_mgnt_callback](#tkl_wifi_register_recv_mgnt_callback)

------
# APIs

## tkl_wifi_init

```c
OPERATE_RET tkl_wifi_init(WIFI_EVENT_CB cb)
```

- **函数描述**

  设置wifi工作状态
  
- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | cb | wifi工作状态回调 |

- **返回值**

  ```
  OPRT_OK : 成功
  Others ：失败
  ```

  
  
## tkl_wifi_scan_ap

```c
OPERATE_RET tkl_wifi_scan_ap(CONST SCHAR_T *ssid, AP_IF_S **ap_ary, UINT_T *num)
```

- **函数描述**

  扫描当前环境，获取当前环境中的ap信息


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | ssid |如果ssid = NULL则扫描所有ap, 其他则扫描指定ap|
  | [out] | ap_ary | 扫描结果信息 |
  | [out] | num | 扫描ap个数 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_AP_SCAN_FAILED ：扫描失败
  ```

- **备注**

  ```
  1，阻塞函数
  2，只能扫描到当前国家码信道列表里的ap
  3，当环境存在指定ssid的ap，扫描到该ssid的成功率要超过98%
  4，ap需要在该api内分配内存（扫描到多个ap，需要分配连续的内存空间）
  5，释放该内存由tuya sdk主动调用tuya_hal_wifi_release_ap释放
  ```
  
  
## tkl_wifi_release_ap

```c
OPERATE_RET tkl_wifi_release_ap(AP_IF_S *ap)
```

- **函数描述**

  释放ap信息资源


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | ap | 需要释放的ap信息 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功 
  OPRT_OS_ADAPTER_AP_RELEASE_FAILED ：失败
  ```
  
## tkl_wifi_start_ap

```c
OPERATE_RET tkl_wifi_start_ap(CONST WF_AP_CFG_IF_S *cfg)
```

- **函数描述**

  启动ap模式


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | cfg | ap配置参数 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_AP_START_FAILED ：失败
  ```
  
- **备注**

  ```
  1，需要根据max_conn来设置ap模式下最多允许几个sta能连接成功。
  2，需要根据ip信息来设置ap模式下的ip信息。
  3，stationap模式，如果ap port有连接的情况下staiton port连接路由器，连接过程以及连接
     失败后ap port不可以有断连情况以及可以收发广播包。
  4，配网ez+ap共存：
    4.1 softap或者stationap模式下可以使能sniffer功能以及可以切换信道。
    4.2 使能sniffer功能之后，扔给回调的数据要包括ap port的设备连接请求包。
  ```
  
   
## tkl_wifi_stop_ap

```c
OPERATE_RET tkl_wifi_stop_ap(VOID_T)
```

- **函数描述**

  停止ap模式


- **参数**

  无

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_AP_STOP_FAILED ：失败
  ```

- **备注**

  ```
  1，需要针对设备当前所处模式softap或stationap做不同的关闭逻辑
  2，stationap模式下，如果station port端有连接，关闭ap port过程station port不能有断连情况
  ```
  
  
## tkl_wifi_set_cur_channel

```c
OPERATE_RET tkl_wifi_set_cur_channel(CONST UCHAR_T chan)
```

- **函数描述**

  设置信道


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | chan | 信道 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_CHAN_SET_FAILED ：失败
  ```

- **备注**

  ```
  1，设置当前国家码信道范围之外的信道报失败
  2，支持在sniffer回调里设置信道
  ```
  
## tkl_wifi_get_cur_channel

```c
OPERATE_RET tkl_wifi_get_cur_channel(UCHAR_T *chan);
```

- **函数描述**

  获取当前信道


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [out] | chan | 信道 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_CHAN_GET_FAILED ：失败
  ```
  
## tkl_wifi_set_sniffer

```c
OPERATE_RET tkl_wifi_set_sniffer(CONST BOOL_T en, CONST SNIFFER_CALLBACK cb)
```

- **函数描述**

  设置sniffer功能开关


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | en | 开或关sniffer功能 |
  | [in] | cb | 抓包数据回调 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_SNIFFER_SET_FAILED ：失败
  ```

- **备注**

  返给应用的数据要括管理包数据
  
  
  
  
## tkl_wifi_get_ip

```c
OPERATE_RET tkl_wifi_get_ip(CONST WF_IF_E wf, NW_IP_S *ip)
```

- **函数描述**

  获取wifi的ip信息（ip地址、网关地址、地址掩码）


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | wf | wifi模式 |
  | [out] | ip | ip信息 |
  |--------|--------|
  | WF_STATION | station type|
  | WF_AP | ap type |
  
- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_IP_GET_FAILED ：失败
  ```

- **备注**
  需要区分不同模式（依据传参wf）下的ip信息
  
  
## tkl_wifi_set_ip

```c
OPERATE_RET tkl_wifi_set_ip(CONST WF_IF_E wf, NW_IP_S *ip)
```

- **函数描述**

  设置wifi的静态ip信息（ip地址、网关地址、地址掩码）


- **参数**

  | 输入/输出  | 参数名       | 描述     |
  | ---------- | ------------ | -------- |
  | [in]       | wf           | wifi模式 |
  | [in]       | ip           | ip信息   |
  | --------   | --------     |          |
  | WF_STATION | station type |          |
  | WF_AP      | ap type      |          |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_IP_GET_FAILED ：失败
  ```

- **备注**
  需要区分不同模式（依据传参wf）下的ip信息



## tkl_wifi_set_mac

```c
OPERATE_RET tkl_wifi_set_mac(CONST WF_IF_E wf, CONST NW_MAC_S *mac)
```

- **函数描述**

  设置mac地址


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | wf | wifi模式 |
  | [in] | mac | mac地址 |
  |--------|--------|
  | WF_STATION | station type|
  | WF_AP | ap type |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_MAC_SET_FAILED：失败
  ```


- **备注**

  永久生效，断电不丢失
  
  

  
## tkl_wifi_get_mac

```c
OPERATE_RET tkl_wifi_get_mac(CONST WF_IF_E wf, NW_MAC_S *mac);
```

- **函数描述**

  获取mac地址


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | wf | wifi模式 |
  | [out] | mac | mac地址 |
  |--------|--------|
  | WF_STATION | station type|
  | WF_AP | ap type |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_MAC_GET_FAILED ：失败
  ```

- **备注**

  STATIONAP模式下的mac地址需要区分工作模式（依据传参wf）
  
  
  
## tkl_wifi_set_work_mode

```c
OPERATE_RET tkl_wifi_set_work_mode(CONST WF_WK_MD_E mode)
```

- **函数描述**

  设置wifi工作模式


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | mode | wifi工作模式 |
  |--------|--------|
  | WWM_LOWPOWER | 低功耗（指关闭wifi模块）|
  | WWM_SNIFFER | monitor |
  | WWM_STATION | station |
  | WWM_SOFTAP | softap |
  | WWM_STATIONAP | stationap |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_WORKMODE_SET_FAILED ：失败
  ```

- **备注**

  ```
  1，从设备上电到调用tuya entrance要求在200ms以内。
  2，如果设备初始化时间超过200ms，底层可以做一些必要的初始化之后就调用tuya entrance，
     将耗时间的wifi初始化放在另一个线程执行。
  3，tuya_hal_wifi_set_work_mode是tuya业务使用wifi调用的第一个api，在这个api需要判断wifi初始化是否结束，
     如果没结束，要在这里等到结束才开始往下执行（只需要判断一次）。
  4，如果设备从上电到tuya entrance少于200ms，无需考虑这点。
  ```

## tkl_wifi_get_work_mode

```c
OPERATE_RET tkl_wifi_get_work_mode(WF_WK_MD_E *mode)
```

- **函数描述**

  获取wifi工作模式


- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [out] | mode | wifi工作模式 |
  |--------|--------|
  | WWM_LOWPOWER | 低功耗（指关闭wifi模块）|
  | WWM_SNIFFER | monitor |
  | WWM_STATION | station |
  | WWM_SOFTAP | softap |
  | WWM_STATIONAP | stationap |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_WORKMODE_GET_FAILED ：失败
  ```
  
   
  
## tkl_wifi_get_connected_ap_info

```c
OPERATE_RET tkl_wifi_get_connected_ap_info(FAST_WF_CONNECTED_AP_INFO_T **fast_ap_info)
```

- **函数描述**

  获取所连ap信息，用于快连功能

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [out] | fast_ap_info | 所连ap信息 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_APINFO_GET_FAILED ：失败
  ```
  
- **备注**
  
  ```
  1，fast_ap_info 需要在该api内动态申请内存
  2, 每次重连路由器成功都会获取一次路由器信息，如有更新会同步到flash
  ```
  
  
  
## tkl_wifi_get_bssid

```c
OPERATE_RET tkl_wifi_get_bssid(UCHAR_T *mac)
```

- **函数描述**

  获取所连ap的mac地址

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [out] | mac | mac地址 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_BSSID_GET_FAILED ：失败
  ```
  
  
## tkl_wifi_set_country_code

```c
OPERATE_RET tkl_wifi_set_country_code(CONST COUNTRY_CODE_E ccode)
```

- **函数描述**

  设置国家码

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | ccode | 国家码 |
  |--------|--------|
  | COUNTRY_CODE_CN | 中国区 1-13 |
  | COUNTRY_CODE_US | 美国区 1-11 |
  | COUNTRY_CODE_JP | 日本区 1-14 |
  | COUNTRY_CODE_EU | 欧洲区 1-13 需要考虑欧洲自适应 |
  
- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_CCODE_SET_FAILED ：失败
  ```
  
- **备注**
  ```
  1，国家码暂时只需要支持中国区（CN 1-13）、美国区（US 1-11）、日本区（JP 1-14）、欧洲区（EU 1-13）
  2，针对不同的国家码，需要达到的要求如下：
    2.1 扫描路由器时只能扫到国家码对应信道列表的ap。
    2.2 欧洲区需要实现欧洲自适应功能
    2.3 设置信道时，设置的信道不在当前国家码的信道列表范围之内，设置信道返回error
  ```


## tkl_wifi_set_rf_calibrated

```c
OPERATE_RET tkl_wifi_set_rf_calibrated(VOID_T);
```

- **函数描述**

  检查RF是否校准过

- **参数**

  无

- **返回值**

  ```
  true : 已校准
  false ：未校准
  ```
  
    
## tkl_wifi_set_lp_mode

```c
OPERATE_RET tkl_wifi_set_lp_mode(CONST BOOL_T enable, CONST UCHAR_T dtim)
```

- **函数描述**

  wifi低功耗设置

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | enable |  是否开启wifi低功耗模式|
  | [in] | dtim | dtim参数 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_WF_LPMODE_SET_FAILED ：失败
  ```
  
  
  
## tkl_wifi_station_fast_connect

```c
OPERATE_RET tkl_wifi_station_fast_connect(CONST FAST_WF_CONNECTED_AP_INFO_T *fast_ap_info)
```

- **函数描述**

  快速连接路由器

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | fast_ap_info | 快连所需的ap信息 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_FAST_CONN_FAILED ：失败
  ```
  
- **备注**

  配过网且重启之后第一次连接才会调用这个函数
  
  
  
## tkl_wifi_station_connect

```c
OPERATE_RET tkl_wifi_station_connect(CONST SCHAR_T *ssid, CONST SCHAR_T *passwd)
```

- **函数描述**

  连接路由器

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | ssid | ssid |
  | [in] | passwd | passwd |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_CONN_FAILED ：失败
  ```
  
- **备注**

  ```
  1，非阻塞，启动连接流程成功后，上层会每隔1s钟调用tuya_hal_wifi_station_get_status查询wifi连接状态
  2，需要使能自动重连功能，重连时间在1min以内即可，上层断连情况下会每隔1min发起一次重连
  ```
  
  
  
## tkl_wifi_station_disconnect

```c
OPERATE_RET tkl_wifi_station_disconnect(VOID_T)
```

- **函数描述**

  断开路由器

- **参数**

  无

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_DISCONN_FAILED ：失败
  ```
  
  
  
## tkl_wifi_station_get_conn_ap_rssi

```c
OPERATE_RET tkl_wifi_station_get_conn_ap_rssi(SCHAR_T *rssi)
```

- **函数描述**

  获取所连ap的信号强度

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [out] | rssi | 信号强度 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_RSSI_GET_FAILED ：失败
  ```
  
- **备注**

  ```
  1，不移动设备和路由器的位置，多次获取rssi只能出现小范围的波动
  2，移动设备和路由器的位置，获取rssi会有对应的变化
  ```
  
  
  
    
## tkl_wifi_station_get_status

```c
OPERATE_RET tkl_wifi_station_get_status(WF_STATION_STAT_E *stat)
```

- **函数描述**

  获取wifi当前的连接状态

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [out] | stat | 连接状态 |
  |--------|--------|
  | WSS_IDLE |  |
  | WSS_CONNECTING | 连接中 |
  | WSS_PASSWD_WRONG | 密码错误 |
  | WSS_CONN_FAIL | 连接失败 |
  | WSS_CONN_SUCCESS | 连接成功 |
  | WSS_GOT_IP | dhcp成功 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_STAT_GET_FAILED ：失败
  ```
  
  
  
## tkl_wifi_send_mgnt

```c
OPERATE_RET tkl_wifi_send_mgnt(CONST UCHAR_T *buf, CONST UINT_T len)
```

- **函数描述**

  发送管理包数据

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | buf | 管理包数据buf |
  | [in] | len | 管理包数据长度 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_MGNT_SEND_FAILED ：失败
  ```
  
## tkl_wifi_register_recv_mgnt_callback

```c
OPERATE_RET tkl_wifi_register_recv_mgnt_callback(CONST BOOL_T enable, CONST WIFI_REV_MGNT_CB recv_cb)
```

- **函数描述**

  设置应用层是否接收管理包数据

- **参数**

  | 输入/输出 |  参数名  |  描述  |
  |--------|--------|--------|
  | [in] | enable |  是否开启接收管理包数据
  | [in] | recv_cb | 接收管理包数据回调 |

- **返回值**

  ```
  OPRT_OS_ADAPTER_OK : 成功
  OPRT_OS_ADAPTER_MGNT_REG_FAILED ：失败
  ```